(* Automatically generated from <a href="#doc.ml">doc.ml</a> *)
module Date :
  sig
    type t = int * int
    val compare : 'a * 'b -> 'a * 'b -> int
    val of_string : string -> int * int
    val to_string : int * int -> string
  end
type fruit = [ `Apple | `Banana | `Orange | `Passion ]
module Fruit :
  sig
    type t = fruit
    exception Bad_format
    val of_string : string -> [> `Apple | `Banana | `Orange | `Passion ]
    val to_string : [< `Apple | `Banana | `Orange | `Passion ] -> string
    val of_int : int -> [> `Apple | `Banana | `Orange | `Passion ]
    val to_int : [< `Apple | `Banana | `Orange | `Passion ] -> int
    val compare :
      [< `Apple | `Banana | `Orange | `Passion ] ->
      [< `Apple | `Banana | `Orange | `Passion ] -> int
  end
type example = {
  alpha : string;
  bravo : string;
  charlie : string;
  delta : string;
  echo : string;
  foxtrot : int;
  golf : int option;
  hotel : int option;
  india : float;
  juliet : float option;
  kilo : bool;
  lima : bool option;
  mike : Date.t;
  november : Date.t option;
  oscar : [ `Apple | `Orange ];
  papa : [ `Apple | `Banana ];
  quebec : Fruit.t;
  mutable romeo : int;
}
module Example :
  sig
    val create :
      alpha:string ->
      bravo:string ->
      ?charlie:string ->
      delta:string ->
      ?echo:string ->
      foxtrot:int ->
      golf:int option ->
      ?hotel:int option ->
      india:float ->
      juliet:float option ->
      kilo:bool ->
      lima:bool option ->
      mike:Date.t ->
      ?november:Date.t option ->
      oscar:[ `Apple | `Orange ] ->
      ?papa:[ `Apple | `Banana ] ->
      ?quebec:Fruit.t -> romeo:int -> unit -> example
    val create_tuple :
      alpha:string ->
      bravo:string ->
      ?charlie:string ->
      delta:string ->
      ?echo:string ->
      foxtrot:int ->
      golf:int option ->
      ?hotel:int option ->
      india:float ->
      juliet:float option ->
      kilo:bool ->
      lima:bool option ->
      mike:Date.t ->
      ?november:Date.t option ->
      oscar:[ `Apple | `Orange ] ->
      ?papa:[ `Apple | `Banana ] ->
      ?quebec:Fruit.t ->
      romeo:int ->
      unit ->
      string * string * string * string * string * int * int option *
      int option * float * float option * bool * bool option * Date.t *
      Date.t option * [ `Apple | `Orange ] * [ `Apple | `Banana ] * Fruit.t *
      int
    class obj :
      alpha:string ->
      bravo:string ->
      ?charlie:string ->
      delta:string ->
      ?echo:string ->
      foxtrot:int ->
      golf:int option ->
      ?hotel:int option ->
      india:float ->
      juliet:float option ->
      kilo:bool ->
      lima:bool option ->
      mike:Date.t ->
      ?november:Date.t option ->
      oscar:[ `Apple | `Orange ] ->
      ?papa:[ `Apple | `Banana ] ->
      ?quebec:Fruit.t ->
      romeo:int ->
      unit ->
      object
        val mutable romeo : int
        val quebec : Fruit.t
        val papa : [ `Apple | `Banana ]
        val oscar : [ `Apple | `Orange ]
        val november : Date.t option
        val mike : Date.t
        val lima : bool option
        val kilo : bool
        val juliet : float option
        val india : float
        val hotel : int option
        val golf : int option
        val foxtrot : int
        val echo : string
        val delta : string
        val charlie : string
        val bravo : string
        val alpha : string
        method alpha : string
        method bravo : string
        method charlie : string
        method delta : string
        method echo : string
        method foxtrot : int
        method golf : int option
        method hotel : int option
        method india : float
        method juliet : float option
        method kilo : bool
        method lima : bool option
        method mike : Date.t
        method november : Date.t option
        method oscar : [ `Apple | `Orange ]
        method papa : [ `Apple | `Banana ]
        method quebec : Fruit.t
        method romeo : int
        method set_romeo : int -> unit
      end
    exception Bad_format
    val alpha_of_string : string -> string
    val alpha_to_string : string -> string
    val bravo_of_string : string -> string
    val bravo_to_string : string -> string
    val charlie_of_string : string -> string
    val charlie_to_string : string -> string
    val delta_of_string : string -> string
    val delta_to_string : string -> string
    val echo_of_string : string -> string
    val echo_to_string : string -> string
    val foxtrot_of_string : string -> int
    val foxtrot_to_string : int -> string
    val golf_of_string : string -> int option
    val golf_to_string : int option -> string
    val hotel_of_string : string -> int option
    val hotel_to_string : int option -> string
    val india_of_string : string -> float
    val india_to_string : float -> string
    val juliet_of_string : string -> float option
    val juliet_to_string : float option -> string
    val kilo_of_string : string -> bool
    val kilo_to_string : bool -> string
    val lima_of_string : string -> bool option
    val lima_to_string : bool option -> string
    val mike_of_string : string -> int * int
    val mike_to_string : int * int -> string
    val november_of_string : string -> (int * int) option
    val november_to_string : Date.t option -> string
    val oscar_of_string : string -> [> `Apple | `Orange ]
    val oscar_to_string : [< `Apple | `Orange ] -> string
    val papa_of_string : string -> [> `Apple | `Banana ]
    val papa_to_string : [< `Apple | `Banana ] -> string
    val quebec_of_string :
      string -> [> `Apple | `Banana | `Orange | `Passion ]
    val quebec_to_string :
      [< `Apple | `Banana | `Orange | `Passion ] -> string
    val romeo_of_string : string -> int
    val romeo_to_string : int -> string
    type t = example
    module Index :
      sig
        val alpha : int
        val bravo : int
        val charlie : int
        val delta : int
        val echo : int
        val foxtrot : int
        val golf : int
        val hotel : int
        val india : int
        val juliet : int
        val kilo : int
        val lima : int
        val mike : int
        val november : int
        val oscar : int
        val papa : int
        val quebec : int
        val romeo : int
      end
    module Compare :
      sig
        val alpha : String.t -> String.t -> int
        val bravo : String.t -> String.t -> int
        val charlie : String.t -> String.t -> int
        val delta : String.t -> String.t -> int
        val echo : String.t -> String.t -> int
        val foxtrot : 'a -> 'a -> int
        val golf : int option -> int option -> int
        val hotel : int option -> int option -> int
        val india : 'a -> 'a -> int
        val juliet : float option -> float option -> int
        val kilo : 'a -> 'a -> int
        val lima : bool option -> bool option -> int
        val mike : 'a * 'b -> 'a * 'b -> int
        val november : (int * int) option -> (int * int) option -> int
        val oscar : [< `Apple | `Orange ] -> [< `Apple | `Orange ] -> int
        val papa : [< `Apple | `Banana ] -> [< `Apple | `Banana ] -> int
        val quebec :
          [< `Apple | `Banana | `Orange | `Passion ] ->
          [< `Apple | `Banana | `Orange | `Passion ] -> int
        val romeo : 'a -> 'a -> int
      end
    val fields : string array
    val labels : string array
    val of_array : string array -> example
    val to_array : example -> string array
    exception Invalid_field of string
    exception Invalid_label of string
    val type_string_field : string -> t -> string
    val type_string_label : string -> t -> string
    val type_float_field : string -> t -> float
    val type_float_label : string -> t -> float
    val type_Fruit_field : string -> t -> Fruit.t
    val type_Fruit_label : string -> t -> Fruit.t
    val type_Date_field : string -> t -> Date.t
    val type_Date_label : string -> t -> Date.t
    val type_Date_option_field : string -> t -> Date.t option
    val type_Date_option_label : string -> t -> Date.t option
    val type_int_option_field : string -> t -> int option
    val type_int_option_label : string -> t -> int option
    val type_float_option_field : string -> t -> float option
    val type_float_option_label : string -> t -> float option
    val type_bool_option_field : string -> t -> bool option
    val type_bool_option_label : string -> t -> bool option
    val type_bool_field : string -> t -> bool
    val type_bool_label : string -> t -> bool
    val type_int_field : string -> t -> int
    val type_int_label : string -> t -> int
    val load_csv_rows :
      ?strict:bool -> ?noheader:bool -> string -> (example -> unit) -> unit
    val load_csv :
      ?strict:bool -> ?noheader:bool -> ?rev:bool -> string -> example list
    val open_out_csv :
      ?sep:char ->
      ?noheader:bool -> string -> (example -> unit) * (unit -> unit)
    val save_csv_rows :
      ?sep:char ->
      ?noheader:bool -> string -> (unit -> example option) -> unit
    val save_csv :
      ?sep:char -> ?noheader:bool -> string -> example list -> unit
    val compare_fields :
      [< `Custom of example -> example -> int
       | `Down of string
       | `Up of string ]
      list -> example -> example -> int
    val compare_labels :
      [< `Custom of example -> example -> int
       | `Down of string
       | `Up of string ]
      list -> example -> example -> int
    module Tup :
      sig
        type t =
          string * string * string * string * string * int * int option *
          int option * float * float option * bool * bool option * Date.t *
          Date.t option * [ `Apple | `Orange ] * [ `Apple | `Banana ] *
          Fruit.t * int
        val create :
          alpha:string ->
          bravo:string ->
          ?charlie:string ->
          delta:string ->
          ?echo:string ->
          foxtrot:int ->
          golf:int option ->
          ?hotel:int option ->
          india:float ->
          juliet:float option ->
          kilo:bool ->
          lima:bool option ->
          mike:Date.t ->
          ?november:Date.t option ->
          oscar:[ `Apple | `Orange ] ->
          ?papa:[ `Apple | `Banana ] ->
          ?quebec:Fruit.t ->
          romeo:int ->
          unit ->
          string * string * string * string * string * int * int option *
          int option * float * float option * bool * bool option * Date.t *
          Date.t option * [ `Apple | `Orange ] * [ `Apple | `Banana ] *
          Fruit.t * int
        val of_array :
          string array ->
          string * string * string * string * string * int * int option *
          int option * float * float option * bool * bool option *
          (int * int) * (int * int) option * [> `Apple | `Orange ] *
          [> `Apple | `Banana ] *
          [> `Apple | `Banana | `Orange | `Passion ] * int
        val to_array :
          string * string * string * string * string * int * int option *
          int option * float * float option * bool * bool option *
          (int * int) * Date.t option * [< `Apple | `Orange ] *
          [< `Apple | `Banana ] *
          [< `Apple | `Banana | `Orange | `Passion ] * int -> string array
        val of_record : example -> t
        val to_record : t -> example
        val get_alpha : t -> string
        val get_bravo : t -> string
        val get_charlie : t -> string
        val get_delta : t -> string
        val get_echo : t -> string
        val get_foxtrot : t -> int
        val get_golf : t -> int option
        val get_hotel : t -> int option
        val get_india : t -> float
        val get_juliet : t -> float option
        val get_kilo : t -> bool
        val get_lima : t -> bool option
        val get_mike : t -> Date.t
        val get_november : t -> Date.t option
        val get_oscar : t -> [ `Apple | `Orange ]
        val get_papa : t -> [ `Apple | `Banana ]
        val get_quebec : t -> Fruit.t
        val get_romeo : t -> int
        exception Invalid_field of string
        exception Invalid_label of string
        val type_string_field : string -> t -> string
        val type_string_label : string -> t -> string
        val type_float_field : string -> t -> float
        val type_float_label : string -> t -> float
        val type_Fruit_field : string -> t -> Fruit.t
        val type_Fruit_label : string -> t -> Fruit.t
        val type_Date_field : string -> t -> Date.t
        val type_Date_label : string -> t -> Date.t
        val type_Date_option_field : string -> t -> Date.t option
        val type_Date_option_label : string -> t -> Date.t option
        val type_int_option_field : string -> t -> int option
        val type_int_option_label : string -> t -> int option
        val type_float_option_field : string -> t -> float option
        val type_float_option_label : string -> t -> float option
        val type_bool_option_field : string -> t -> bool option
        val type_bool_option_label : string -> t -> bool option
        val type_bool_field : string -> t -> bool
        val type_bool_label : string -> t -> bool
        val type_int_field : string -> t -> int
        val type_int_label : string -> t -> int
        val load_csv_rows :
          ?strict:bool ->
          ?noheader:bool ->
          string ->
          (string * string * string * string * string * int * int option *
           int option * float * float option * bool * bool option *
           (int * int) * (int * int) option * [> `Apple | `Orange ] *
           [> `Apple | `Banana ] *
           [> `Apple | `Banana | `Orange | `Passion ] * int -> unit) ->
          unit
        val load_csv :
          ?strict:bool ->
          ?noheader:bool ->
          ?rev:bool ->
          string ->
          (string * string * string * string * string * int * int option *
           int option * float * float option * bool * bool option *
           (int * int) * (int * int) option * [> `Apple | `Orange ] *
           [> `Apple | `Banana ] *
           [> `Apple | `Banana | `Orange | `Passion ] * int)
          list
        val open_out_csv :
          ?sep:char ->
          ?noheader:bool ->
          string ->
          (string * string * string * string * string * int * int option *
           int option * float * float option * bool * bool option *
           (int * int) * Date.t option * [< `Apple | `Orange ] *
           [< `Apple | `Banana ] *
           [< `Apple | `Banana | `Orange | `Passion ] * int -> unit) *
          (unit -> unit)
        val save_csv_rows :
          ?sep:char ->
          ?noheader:bool ->
          string ->
          (unit ->
           (string * string * string * string * string * int * int option *
            int option * float * float option * bool * bool option *
            (int * int) * Date.t option * [< `Apple | `Orange ] *
            [< `Apple | `Banana ] *
            [< `Apple | `Banana | `Orange | `Passion ] * int)
           option) ->
          unit
        val save_csv :
          ?sep:char ->
          ?noheader:bool ->
          string ->
          (string * string * string * string * string * int * int option *
           int option * float * float option * bool * bool option *
           (int * int) * Date.t option * [< `Apple | `Orange ] *
           [< `Apple | `Banana ] *
           [< `Apple | `Banana | `Orange | `Passion ] * int)
          list -> unit
        val compare_fields :
          [< `Custom of t -> t -> int | `Down of string | `Up of string ]
          list -> t -> t -> int
        val compare_labels :
          [< `Custom of t -> t -> int | `Down of string | `Up of string ]
          list -> t -> t -> int
      end
    module OO :
      sig
        class t :
          alpha:string ->
          bravo:string ->
          ?charlie:string ->
          delta:string ->
          ?echo:string ->
          foxtrot:int ->
          golf:int option ->
          ?hotel:int option ->
          india:float ->
          juliet:float option ->
          kilo:bool ->
          lima:bool option ->
          mike:Date.t ->
          ?november:Date.t option ->
          oscar:[ `Apple | `Orange ] ->
          ?papa:[ `Apple | `Banana ] ->
          ?quebec:Fruit.t -> romeo:int -> unit -> obj
        val create :
          alpha:string ->
          bravo:string ->
          ?charlie:string ->
          delta:string ->
          ?echo:string ->
          foxtrot:int ->
          golf:int option ->
          ?hotel:int option ->
          india:float ->
          juliet:float option ->
          kilo:bool ->
          lima:bool option ->
          mike:Date.t ->
          ?november:Date.t option ->
          oscar:[ `Apple | `Orange ] ->
          ?papa:[ `Apple | `Banana ] ->
          ?quebec:Fruit.t -> romeo:int -> unit -> t
        val of_array : string array -> t
        val to_array :
          < alpha : string; bravo : string; charlie : string; delta : 
            string; echo : string; foxtrot : int; golf : int option;
            hotel : int option; india : float; juliet : float option;
            kilo : bool; lima : bool option; mike : int * int;
            november : Date.t option; oscar : [< `Apple | `Orange ];
            papa : [< `Apple | `Banana ];
            quebec : [< `Apple | `Banana | `Orange | `Passion ]; romeo : 
            int; .. > ->
          string array
        val of_record : example -> t
        val to_record :
          < alpha : string; bravo : string; charlie : string; delta : 
            string; echo : string; foxtrot : int; golf : int option;
            hotel : int option; india : float; juliet : float option;
            kilo : bool; lima : bool option; mike : Date.t;
            november : Date.t option; oscar : [ `Apple | `Orange ];
            papa : [ `Apple | `Banana ]; quebec : Fruit.t; romeo : int; .. > ->
          example
        exception Invalid_field of string
        exception Invalid_label of string
        val type_string_field : string -> t -> string
        val type_string_label : string -> t -> string
        val type_float_field : string -> t -> float
        val type_float_label : string -> t -> float
        val type_Fruit_field : string -> t -> Fruit.t
        val type_Fruit_label : string -> t -> Fruit.t
        val type_Date_field : string -> t -> Date.t
        val type_Date_label : string -> t -> Date.t
        val type_Date_option_field : string -> t -> Date.t option
        val type_Date_option_label : string -> t -> Date.t option
        val type_int_option_field : string -> t -> int option
        val type_int_option_label : string -> t -> int option
        val type_float_option_field : string -> t -> float option
        val type_float_option_label : string -> t -> float option
        val type_bool_option_field : string -> t -> bool option
        val type_bool_option_label : string -> t -> bool option
        val type_bool_field : string -> t -> bool
        val type_bool_label : string -> t -> bool
        val type_int_field : string -> t -> int
        val type_int_label : string -> t -> int
        val load_csv_rows :
          ?strict:bool -> ?noheader:bool -> string -> (t -> unit) -> unit
        val load_csv :
          ?strict:bool -> ?noheader:bool -> ?rev:bool -> string -> t list
        val open_out_csv :
          ?sep:char ->
          ?noheader:bool ->
          string ->
          (< alpha : string; bravo : string; charlie : string;
             delta : string; echo : string; foxtrot : int; golf : int option;
             hotel : int option; india : float; juliet : float option;
             kilo : bool; lima : bool option; mike : int * int;
             november : Date.t option; oscar : [< `Apple | `Orange ];
             papa : [< `Apple | `Banana ];
             quebec : [< `Apple | `Banana | `Orange | `Passion ];
             romeo : int; .. > ->
           unit) *
          (unit -> unit)
        val save_csv_rows :
          ?sep:char ->
          ?noheader:bool ->
          string ->
          (unit ->
           < alpha : string; bravo : string; charlie : string;
             delta : string; echo : string; foxtrot : int; golf : int option;
             hotel : int option; india : float; juliet : float option;
             kilo : bool; lima : bool option; mike : int * int;
             november : Date.t option; oscar : [< `Apple | `Orange ];
             papa : [< `Apple | `Banana ];
             quebec : [< `Apple | `Banana | `Orange | `Passion ];
             romeo : int; .. >
           option) ->
          unit
        val save_csv :
          ?sep:char ->
          ?noheader:bool ->
          string ->
          < alpha : string; bravo : string; charlie : string; delta : 
            string; echo : string; foxtrot : int; golf : int option;
            hotel : int option; india : float; juliet : float option;
            kilo : bool; lima : bool option; mike : int * int;
            november : Date.t option; oscar : [< `Apple | `Orange ];
            papa : [< `Apple | `Banana ];
            quebec : [< `Apple | `Banana | `Orange | `Passion ]; romeo : 
            int; .. >
          list -> unit
        val compare_fields :
          [< `Custom of
               (< alpha : String.t; bravo : String.t; charlie : String.t;
                  delta : String.t; echo : String.t; foxtrot : 'b;
                  golf : int option; hotel : int option; india : 'c;
                  juliet : float option; kilo : 'd; lima : bool option;
                  mike : 'e * 'f; november : (int * int) option;
                  oscar : [< `Apple | `Orange ];
                  papa : [< `Apple | `Banana ];
                  quebec : [< `Apple | `Banana | `Orange | `Passion ];
                  romeo : 'g; .. >
                as 'a) ->
               (< alpha : String.t; bravo : String.t; charlie : String.t;
                  delta : String.t; echo : String.t; foxtrot : 'b;
                  golf : int option; hotel : int option; india : 'c;
                  juliet : float option; kilo : 'd; lima : bool option;
                  mike : 'e * 'f; november : (int * int) option;
                  oscar : [< `Apple | `Orange ];
                  papa : [< `Apple | `Banana ];
                  quebec : [< `Apple | `Banana | `Orange | `Passion ];
                  romeo : 'g; .. >
                as 'h) ->
               int
           | `Down of string
           | `Up of string ]
          list -> 'a -> 'h -> int
        val compare_labels :
          [< `Custom of
               (< alpha : String.t; bravo : String.t; charlie : String.t;
                  delta : String.t; echo : String.t; foxtrot : 'b;
                  golf : int option; hotel : int option; india : 'c;
                  juliet : float option; kilo : 'd; lima : bool option;
                  mike : 'e * 'f; november : (int * int) option;
                  oscar : [< `Apple | `Orange ];
                  papa : [< `Apple | `Banana ];
                  quebec : [< `Apple | `Banana | `Orange | `Passion ];
                  romeo : 'g; .. >
                as 'a) ->
               (< alpha : String.t; bravo : String.t; charlie : String.t;
                  delta : String.t; echo : String.t; foxtrot : 'b;
                  golf : int option; hotel : int option; india : 'c;
                  juliet : float option; kilo : 'd; lima : bool option;
                  mike : 'e * 'f; november : (int * int) option;
                  oscar : [< `Apple | `Orange ];
                  papa : [< `Apple | `Banana ];
                  quebec : [< `Apple | `Banana | `Orange | `Passion ];
                  romeo : 'g; .. >
                as 'h) ->
               int
           | `Down of string
           | `Up of string ]
          list -> 'a -> 'h -> int
      end
  end
module Test_predef :
  sig
    module File_kind :
      sig
        type t = Unix.file_kind
        exception Bad_format
        val of_string : string -> Unix.file_kind
        val to_string : Unix.file_kind -> string
        val of_int : int -> Unix.file_kind
        val to_int : Unix.file_kind -> int
        val compare : Unix.file_kind -> Unix.file_kind -> int
      end
    module Stats :
      sig
        val create :
          st_dev:int ->
          st_ino:int ->
          st_kind:Unix.file_kind ->
          st_perm:Unix.file_perm ->
          st_nlink:int ->
          st_uid:int ->
          st_gid:int ->
          st_rdev:int ->
          st_size:int ->
          st_atime:float ->
          st_mtime:float -> st_ctime:float -> unit -> Unix.stats
        val create_tuple :
          st_dev:int ->
          st_ino:int ->
          st_kind:File_kind.t ->
          st_perm:int ->
          st_nlink:int ->
          st_uid:int ->
          st_gid:int ->
          st_rdev:int ->
          st_size:int ->
          st_atime:float ->
          st_mtime:float ->
          st_ctime:float ->
          unit ->
          int * int * File_kind.t * int * int * int * int * int * int *
          float * float * float
        class obj :
          st_dev:int ->
          st_ino:int ->
          st_kind:File_kind.t ->
          st_perm:int ->
          st_nlink:int ->
          st_uid:int ->
          st_gid:int ->
          st_rdev:int ->
          st_size:int ->
          st_atime:float ->
          st_mtime:float ->
          st_ctime:float ->
          unit ->
          object
            val st_uid : int
            val st_size : int
            val st_rdev : int
            val st_perm : int
            val st_nlink : int
            val st_mtime : float
            val st_kind : File_kind.t
            val st_ino : int
            val st_gid : int
            val st_dev : int
            val st_ctime : float
            val st_atime : float
            method st_atime : float
            method st_ctime : float
            method st_dev : int
            method st_gid : int
            method st_ino : int
            method st_kind : File_kind.t
            method st_mtime : float
            method st_nlink : int
            method st_perm : int
            method st_rdev : int
            method st_size : int
            method st_uid : int
          end
        exception Bad_format
        val st_dev_of_string : string -> int
        val st_dev_to_string : int -> string
        val st_ino_of_string : string -> int
        val st_ino_to_string : int -> string
        val st_kind_of_string : string -> Unix.file_kind
        val st_kind_to_string : Unix.file_kind -> string
        val st_perm_of_string : string -> int
        val st_perm_to_string : int -> string
        val st_nlink_of_string : string -> int
        val st_nlink_to_string : int -> string
        val st_uid_of_string : string -> int
        val st_uid_to_string : int -> string
        val st_gid_of_string : string -> int
        val st_gid_to_string : int -> string
        val st_rdev_of_string : string -> int
        val st_rdev_to_string : int -> string
        val st_size_of_string : string -> int
        val st_size_to_string : int -> string
        val st_atime_of_string : string -> float
        val st_atime_to_string : float -> string
        val st_mtime_of_string : string -> float
        val st_mtime_to_string : float -> string
        val st_ctime_of_string : string -> float
        val st_ctime_to_string : float -> string
        type t = Unix.stats
        module Index :
          sig
            val st_dev : int
            val st_ino : int
            val st_kind : int
            val st_perm : int
            val st_nlink : int
            val st_uid : int
            val st_gid : int
            val st_rdev : int
            val st_size : int
            val st_atime : int
            val st_mtime : int
            val st_ctime : int
          end
        module Compare :
          sig
            val st_dev : 'a -> 'a -> int
            val st_ino : 'a -> 'a -> int
            val st_kind : Unix.file_kind -> Unix.file_kind -> int
            val st_perm : 'a -> 'a -> int
            val st_nlink : 'a -> 'a -> int
            val st_uid : 'a -> 'a -> int
            val st_gid : 'a -> 'a -> int
            val st_rdev : 'a -> 'a -> int
            val st_size : 'a -> 'a -> int
            val st_atime : 'a -> 'a -> int
            val st_mtime : 'a -> 'a -> int
            val st_ctime : 'a -> 'a -> int
          end
        val fields : string array
        val labels : string array
        val of_array : string array -> Unix.stats
        val to_array : Unix.stats -> string array
        exception Invalid_field of string
        exception Invalid_label of string
        val type_float_field : string -> t -> float
        val type_float_label : string -> t -> float
        val type_File_kind_field : string -> t -> Unix.file_kind
        val type_File_kind_label : string -> t -> Unix.file_kind
        val type_int_field : string -> t -> Unix.file_perm
        val type_int_label : string -> t -> Unix.file_perm
        val load_csv_rows :
          ?strict:bool ->
          ?noheader:bool -> string -> (Unix.stats -> unit) -> unit
        val load_csv :
          ?strict:bool ->
          ?noheader:bool -> ?rev:bool -> string -> Unix.stats list
        val open_out_csv :
          ?sep:char ->
          ?noheader:bool -> string -> (Unix.stats -> unit) * (unit -> unit)
        val save_csv_rows :
          ?sep:char ->
          ?noheader:bool -> string -> (unit -> Unix.stats option) -> unit
        val save_csv :
          ?sep:char -> ?noheader:bool -> string -> Unix.stats list -> unit
        val compare_fields :
          [< `Custom of Unix.stats -> Unix.stats -> int
           | `Down of string
           | `Up of string ]
          list -> Unix.stats -> Unix.stats -> int
        val compare_labels :
          [< `Custom of Unix.stats -> Unix.stats -> int
           | `Down of string
           | `Up of string ]
          list -> Unix.stats -> Unix.stats -> int
        module Tup :
          sig
            type t =
              int * int * File_kind.t * int * int * int * int * int * 
              int * float * float * float
            val create :
              st_dev:int ->
              st_ino:int ->
              st_kind:File_kind.t ->
              st_perm:int ->
              st_nlink:int ->
              st_uid:int ->
              st_gid:int ->
              st_rdev:int ->
              st_size:int ->
              st_atime:float ->
              st_mtime:float ->
              st_ctime:float ->
              unit ->
              int * int * File_kind.t * int * int * int * int * int * 
              int * float * float * float
            val of_array :
              string array ->
              int * int * Unix.file_kind * int * int * int * int * int *
              int * float * float * float
            val to_array :
              int * int * Unix.file_kind * int * int * int * int * int *
              int * float * float * float -> string array
            val of_record : Unix.stats -> t
            val to_record : t -> Unix.stats
            val get_st_dev : t -> int
            val get_st_ino : t -> int
            val get_st_kind : t -> File_kind.t
            val get_st_perm : t -> int
            val get_st_nlink : t -> int
            val get_st_uid : t -> int
            val get_st_gid : t -> int
            val get_st_rdev : t -> int
            val get_st_size : t -> int
            val get_st_atime : t -> float
            val get_st_mtime : t -> float
            val get_st_ctime : t -> float
            exception Invalid_field of string
            exception Invalid_label of string
            val type_float_field : string -> t -> float
            val type_float_label : string -> t -> float
            val type_File_kind_field : string -> t -> File_kind.t
            val type_File_kind_label : string -> t -> File_kind.t
            val type_int_field : string -> t -> int
            val type_int_label : string -> t -> int
            val load_csv_rows :
              ?strict:bool ->
              ?noheader:bool ->
              string ->
              (int * int * Unix.file_kind * int * int * int * int * int *
               int * float * float * float -> unit) ->
              unit
            val load_csv :
              ?strict:bool ->
              ?noheader:bool ->
              ?rev:bool ->
              string ->
              (int * int * Unix.file_kind * int * int * int * int * int *
               int * float * float * float)
              list
            val open_out_csv :
              ?sep:char ->
              ?noheader:bool ->
              string ->
              (int * int * Unix.file_kind * int * int * int * int * int *
               int * float * float * float -> unit) *
              (unit -> unit)
            val save_csv_rows :
              ?sep:char ->
              ?noheader:bool ->
              string ->
              (unit ->
               (int * int * Unix.file_kind * int * int * int * int * 
                int * int * float * float * float)
               option) ->
              unit
            val save_csv :
              ?sep:char ->
              ?noheader:bool ->
              string ->
              (int * int * Unix.file_kind * int * int * int * int * int *
               int * float * float * float)
              list -> unit
            val compare_fields :
              [< `Custom of t -> t -> int | `Down of string | `Up of string ]
              list -> t -> t -> int
            val compare_labels :
              [< `Custom of t -> t -> int | `Down of string | `Up of string ]
              list -> t -> t -> int
          end
        module OO :
          sig
            class t :
              st_dev:int ->
              st_ino:int ->
              st_kind:File_kind.t ->
              st_perm:int ->
              st_nlink:int ->
              st_uid:int ->
              st_gid:int ->
              st_rdev:int ->
              st_size:int ->
              st_atime:float ->
              st_mtime:float -> st_ctime:float -> unit -> obj
            val create :
              st_dev:int ->
              st_ino:int ->
              st_kind:File_kind.t ->
              st_perm:int ->
              st_nlink:int ->
              st_uid:int ->
              st_gid:int ->
              st_rdev:int ->
              st_size:int ->
              st_atime:float -> st_mtime:float -> st_ctime:float -> unit -> t
            val of_array : string array -> t
            val to_array :
              < st_atime : float; st_ctime : float; st_dev : int;
                st_gid : int; st_ino : int; st_kind : Unix.file_kind;
                st_mtime : float; st_nlink : int; st_perm : int;
                st_rdev : int; st_size : int; st_uid : int; .. > ->
              string array
            val of_record : Unix.stats -> t
            val to_record :
              < st_atime : float; st_ctime : float; st_dev : int;
                st_gid : int; st_ino : int; st_kind : Unix.file_kind;
                st_mtime : float; st_nlink : int; st_perm : Unix.file_perm;
                st_rdev : int; st_size : int; st_uid : int; .. > ->
              Unix.stats
            exception Invalid_field of string
            exception Invalid_label of string
            val type_float_field : string -> t -> float
            val type_float_label : string -> t -> float
            val type_File_kind_field : string -> t -> File_kind.t
            val type_File_kind_label : string -> t -> File_kind.t
            val type_int_field : string -> t -> int
            val type_int_label : string -> t -> int
            val load_csv_rows :
              ?strict:bool -> ?noheader:bool -> string -> (t -> unit) -> unit
            val load_csv :
              ?strict:bool -> ?noheader:bool -> ?rev:bool -> string -> t list
            val open_out_csv :
              ?sep:char ->
              ?noheader:bool ->
              string ->
              (< st_atime : float; st_ctime : float; st_dev : int;
                 st_gid : int; st_ino : int; st_kind : Unix.file_kind;
                 st_mtime : float; st_nlink : int; st_perm : int;
                 st_rdev : int; st_size : int; st_uid : int; .. > ->
               unit) *
              (unit -> unit)
            val save_csv_rows :
              ?sep:char ->
              ?noheader:bool ->
              string ->
              (unit ->
               < st_atime : float; st_ctime : float; st_dev : int;
                 st_gid : int; st_ino : int; st_kind : Unix.file_kind;
                 st_mtime : float; st_nlink : int; st_perm : int;
                 st_rdev : int; st_size : int; st_uid : int; .. >
               option) ->
              unit
            val save_csv :
              ?sep:char ->
              ?noheader:bool ->
              string ->
              < st_atime : float; st_ctime : float; st_dev : int;
                st_gid : int; st_ino : int; st_kind : Unix.file_kind;
                st_mtime : float; st_nlink : int; st_perm : int;
                st_rdev : int; st_size : int; st_uid : int; .. >
              list -> unit
            val compare_fields :
              [< `Custom of
                   (< st_atime : 'b; st_ctime : 'c; st_dev : 'd; st_gid : 'e;
                      st_ino : 'f; st_kind : Unix.file_kind; st_mtime : 'g;
                      st_nlink : 'h; st_perm : 'i; st_rdev : 'j;
                      st_size : 'k; st_uid : 'l; .. >
                    as 'a) ->
                   (< st_atime : 'b; st_ctime : 'c; st_dev : 'd; st_gid : 'e;
                      st_ino : 'f; st_kind : Unix.file_kind; st_mtime : 'g;
                      st_nlink : 'h; st_perm : 'i; st_rdev : 'j;
                      st_size : 'k; st_uid : 'l; .. >
                    as 'm) ->
                   int
               | `Down of string
               | `Up of string ]
              list -> 'a -> 'm -> int
            val compare_labels :
              [< `Custom of
                   (< st_atime : 'b; st_ctime : 'c; st_dev : 'd; st_gid : 'e;
                      st_ino : 'f; st_kind : Unix.file_kind; st_mtime : 'g;
                      st_nlink : 'h; st_perm : 'i; st_rdev : 'j;
                      st_size : 'k; st_uid : 'l; .. >
                    as 'a) ->
                   (< st_atime : 'b; st_ctime : 'c; st_dev : 'd; st_gid : 'e;
                      st_ino : 'f; st_kind : Unix.file_kind; st_mtime : 'g;
                      st_nlink : 'h; st_perm : 'i; st_rdev : 'j;
                      st_size : 'k; st_uid : 'l; .. >
                    as 'm) ->
                   int
               | `Down of string
               | `Up of string ]
              list -> 'a -> 'm -> int
          end
      end
    val print_list : string list -> unit
    val print_row : string * Unix.stats -> unit
    val dir : string
    val files : string list
    val stats : (string * Unix.stats) list
    val cmp : Unix.stats -> Unix.stats -> int
    val sort : (String.t * Unix.stats) list -> (String.t * Unix.stats) list
  end
